
!"Pocket Smalltalk fileout - Monday, April 01, 2002-8:31:38 PM"!


!Object constantsFor: 'Resource Databases'!

resourceDB1 '..\..\pocketsmalltalk\palmos\vm16A4.prc'! 
resourceDB2 '*.bin'! !

!Object constantsFor: 'System Properties'!

applicationTitle 'CryptoAid'! 
creatorID 'Tem1'! 
optimization true! !

!Object constantsFor: 'Widgets'!

AboutForm 2055! 
AboutFormOKButton 2005! 
AidForm 1316! 
GoButton 1045! 
HelpAbout 1020! 
HelpInstruct 1021! 
InstructForm 2060! 
InstructFormOKButton 2006! 
IsReallyButton 1043! 
MainMenu 1313! 
PasteButton 1046! 
PuzzleScrollBar 1081! 
PuzzleText 1048! 
ResetButton 1010! 
SolutionScrollBar 1088! 
SolutionText 1041! !

Application subclass: #AidForm
	instanceVariableNames: 'puzzletext solutiontext L1 L2 L1popuplist L2popuplist ptext stext firsttime scrollModel zero_index one_index database'
	classVariableNames: ''!

PopupApplication subclass: #AboutForm
	instanceVariableNames: ''
	classVariableNames: ''!

PopupApplication subclass: #InstructForm
	instanceVariableNames: ''
	classVariableNames: ''!

!AidForm methodsFor: 'aspects'!

L1popuplist
   ^L1popuplist.!

L2popuplist
      ^L2popuplist.!

L1
"value of selected the Crypto letter"
   ^L1.!

L2
"value of selected Solution letter"
      ^L2.!

ptext
"Puzzletext as a list, the Cryptogram puzzle"
      ^ptext.!

stext
"current solution as a List"
      ^stext.!

solutiontext
"value of the current solution"
      ^solutiontext.!

puzzletext
"value of the Cryptogram puzzle"
      ^puzzletext.!

scrollModel
   ^scrollModel.!

handleScrollbarRepeatEvent
      | diff |

      diff := (CEvent lastArgument: 4) - (CEvent lastArgument: 3).
      diff > 0
            ifTrue: [ ( self widgetNamed: #puzzletextField) scroll: diff direction: ##downDirection.
                         ( self widgetNamed: #solutiontextField) scroll: diff direction: ##downDirection ]
            ifFalse: [ ( self widgetNamed: #puzzletextField) scroll: (-1 * diff) direction: ##upDirection.
                          ( self widgetNamed: #solutiontextField) scroll: (-1 * diff) direction: ##upDirection].
        
     ^super handleScrollbarRepeatEvent.!

PasteButtonPressed
 "Paste into Cryptogram text from clipboard"

	| handle length string |
	handle := SYSTRAP ClipboardGetItem: 0 with: PadBuffer.
	handle isNull 
	        ifTrue:  [   ptext := 'Clipboard is empty
Please copy a puzzle first' asString
	                     ]
	       ifFalse:  [  	length := PadBuffer wordAt: 0.
	                        string := String new: length.
	                        SYSTRAP
	                                MemMove: string
	                                from: handle lock
	                                bytes: length.
	                         handle unlock.
	                         ptext := string asString
	                     ].
	
	puzzletext value: ptext asString.
            (self widgetNamed: #puzzletextField) updateModel.
           !

ResetTheScrollbars
" common object BJH"
    ( self widgetNamed: #puzzletextField ) setScrollbar: scrollModel.
    ( self widgetNamed: #solutiontextField ) setScrollbar: scrollModel.
!

zero_index
   ^zero_index.!

one_index
   ^one_index.!

database
   ^database.!

GoButtonPressed

   | index  |
   
            firsttime := false.
            (self widgetNamed: #puzzletextField) updateModel.
            puzzletext value: puzzletext value asString asUppercase.
            ptext := puzzletext value asList.
            stext := puzzletext value asList.
            
             "change puzzletext to all caps, assign puzzletext to solutiontext,
             but change all characters A to Z to a question marks first.
              and retains any other characters"

             "asInteger 65 to 90 are A through Z. see asUpperCase method in Character"
             1 to: (ptext size) do: 
                [:index | ((ptext at: index)  asInteger > 64) & ((ptext at: index)  asInteger  < 91)
                 ifTrue: [ (stext asList) at: index put: $? ]
                     ].
               solutiontext value: stext asString.
               puzzletext value: ptext asString.
               
  "new puzzle needs reset of scrollbars"
    self ResetTheScrollbars.
    
    "delete old puzzle/ solution add new puzzle to database"
   database := Database open: 'CryptoAidDB' mode: ##dmModeReadWrite.	
   database deleteRecord: zero_index.
   database deleteRecord: one_index.
   database insertRecord: (puzzletext value asString) at: zero_index.
   database insertRecord: (solutiontext value asString) at: one_index.
   database close.!

IsReallyButtonPressed
 "replaces selected Cryptogram letter with the selected Solution letter, resetting any previous same crypto letter to question mark first"

  | index L1int L2int oldPosition |
 
 "get current replace values from screen. if firsttime,  these are As"   
       L1 := L1popuplist selection asList.
       L2 := L2popuplist selection asList.

 "check: if GoButton was pressed.  firsttime will be False.  
    Go button initializes solution to ???s"
 
 firsttime ifTrue: [ self GoButtonPressed.
                           L1 := ' '.  L2 := ' '.
                           firsttime := false  ]. 
 
  "reset working strings from current values"
  ptext := puzzletext value asList.
  stext := solutiontext value asList.

  "set integer values for L1 and L2"
  L1int := (L1 at: 1) asInteger.
  L2int := (L2 at: 1) asInteger.
   
"undo any previous L2 values in solutiontext with a question mark" 
   
    1 to: (stext size) do: 
    [:index | 
        ((stext at: index)  asInteger = L2int)  
                 ifTrue: [ (stext asList) at: index put: $? ]
               ].

"replace question marks with L2 character for all L1 characters in puzzletext, in the same position"
  
    1 to: (ptext size) do: 
    [:index | 
        ((ptext at: index)  asInteger == L1int)
                 ifTrue: [ (stext asList) at: index put: (L2int asCharacter)]
                 ].
   "save scrollbar position"              
    oldPosition := ( self widgetNamed: #puzzletextField ) scrollPosition.
    
    solutiontext value: stext asString.
    puzzletext value: ptext asString.
    
    "restore the old position"
       
    ( self widgetNamed: #puzzletextField ) scrollPosition: oldPosition.
    ( self widgetNamed: #solutiontextField ) scrollPosition: oldPosition.  

   "save current incremental solution"   
   database := Database open: 'CryptoAidDB' mode: ##dmModeReadWrite.
   database deleteRecord: one_index.
   database insertRecord: (solutiontext value asString) at: one_index.
   database close.
!

NewButtonPressed
" The New button: Clear form to start another puzzle"
     puzzletext value: ' ' asString.
     solutiontext value: ' ' asString.
     ptext := ' '.
     stext := ' ' asList.
     firsttime := true.! !


!AidForm methodsFor: 'event handling'!

handleFieldChangedEvent
      	self ResetTheScrollbars.
	^false.! !


!AidForm methodsFor: 'Actions'!

HelpAboutItem 
"Show the Help How to Use Form"
   | tempForm |
    tempForm := AboutForm new.
    self popup: tempForm.!

HelpInstructItem 
"Show the Whats a Cryptogram Form"
   | tempForm |
    tempForm := InstructForm new.
    self popup: tempForm.
! !


!AidForm methodsFor: 'events'!

onOpened
	"add database if it does not exist"
       (Database findDatabaseIDByName: 'CryptoAidDB') isNil
	 ifTrue: [
	Database createDatabaseNamed: 'CryptoAidDB'  creatorID: 'Tem1'  type: 'MyDb'  isResourceDB: false.
	database := Database open: 'CryptoAidDB' mode: ##dmModeReadWrite.
	database insertRecord: ('puzzle text'  asString) at: zero_index.
            database insertRecord: ('solution text' asString) at: one_index.
            database setBackupBitForDB: (Database findDatabaseIDByName: 'CryptoAidDB').
            database close.] 
            "reload previously saved puzzle and solution"
            ifFalse: [
            firsttime := false.
            database := Database open: 'CryptoAidDB' mode: ##dmModeReadWrite.
            puzzletext value:  (database recordAsString: zero_index) asString.
            solutiontext value: (database recordAsString: one_index) asString.
            database close.
            (self widgetNamed: #puzzletextField) updateModel.
            ].
! !


!AidForm methodsFor: 'initializing'!

createMenus
    super createMenus.
    self addMenuAction: #HelpAboutItem forID: ##HelpAbout.
    self addMenuAction: #HelpInstructItem forID: ##HelpInstruct.
   !

puzzletext: aCharacter
    ^puzzletext.
!

solutiontext:  aCharacter
      ^solutiontext.!

ptext: aList
      ^ptext.!

stext:  aList
      ^stext.!

zero_index: anInteger
      ^zero_index.!

one_index: anInteger
      ^one_index.!

createComponents
    super createComponents.	
    self add: Button id: ##GoButton name: nil aspect: #GoButtonPressed.
    self add: Button id: ##IsReallyButton name: nil aspect: #IsReallyButtonPressed.
    self add: Button id: ##ResetButton name: nil aspect: #NewButtonPressed. 
    self add: Button id: ##PasteButton name: nil aspect: #PasteButtonPressed.
    self add: Scrollbar id: ##PuzzleScrollBar name: nil aspect: #scrollModel.   
    self add: Scrollbar id: ##SolutionScrollBar name: nil  aspect: #scrollModel.
    self add: TextField id: ##PuzzleText name: #puzzletextField aspect: #puzzletext.
    self add: TextField id: ##SolutionText name: #solutiontextField aspect: #solutiontext.
    self add: Listbox id: 1420 name: #L1popuplistField aspect: #L1popuplist.
    self add: PopupTrigger id: L1popuplist name: #L1Field aspect: #L1.
    self add: Listbox id: 1440 name: #L2popuplistField aspect: #L2popuplist.
    self add: PopupTrigger id: L2popuplist name: #L2Field aspect: #L2.	!

initialize 

super initialize. 

puzzletext := ValueHolder with: ' '. 
solutiontext := ValueHolder with:  ' '.
ptext :=  ' '. 
stext :=  ' '.
L1 := ' '. 
L2 := ' '.

L1popuplist := ListModel list: #('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W' 'X' 'Y' 'Z' ).
L2popuplist := ListModel list: #('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W' 'X' 'Y' 'Z' ).

L1popuplist addDependent: self.
L2popuplist addDependent: self.

scrollModel := ScrollValueHolder with: 0.
scrollModel min: 0; max: 50; pageSize: 4.

firsttime := true.
zero_index := 0 asInteger.
one_index  := 1 asInteger.	! !


!AidForm class methodsFor: 'accessing'!

formID
"Answer the form to load for this class"
   ^##AidForm.
! !


!AboutForm methodsFor: 'initializing'!

createComponents 
   super createComponents. 
   self add: Button id: ##AboutFormOKButton name: nil aspect: #AboutFormOKButtonPressed.! !


!AboutForm methodsFor: 'aspects'!

AboutFormOKButtonPressed
   self leave.
! !


!AboutForm class methodsFor: 'accessing'!

formID
"Answer the form to load for this class"
   ^##AboutForm.! !


!InstructForm methodsFor: 'aspects'!

InstructFormOKButtonPressed
   self leave.! !


!InstructForm methodsFor: 'initializing'!

createComponents 
  super createComponents. 
  self add: Button id: ##InstructFormOKButton name: nil aspect: #InstructFormOKButtonPressed.! !


!InstructForm class methodsFor: 'accessing'!

formID
"Answer the form to load for this class"
   ^##InstructForm.! !


!Object methodsFor: 'printing'!

displayOn: stream
	self printOn: stream.! !


!Object methodsFor: 'printing'!

displayString
	| stream |
	stream := String new writeStream.
	self displayOn: stream.
	^stream contents.! !


!Object methodsFor: 'printing'!

printOn: stream
	stream 
		nextPut: $a;
		space;
		nextPutAll: self class name.! !


!Object methodsFor: 'printing'!

printString
	| stream |
	stream := String new writeStream.
	self printOn: stream.
	^stream contents.! !


!Object methodsFor: 'predicates'!

isKindOf: class
	<primitive: 22>

"Implemented as follows:
	| probe |
	probe := self class.
	[probe isNil] whileFalse: [
		probe == class ifTrue: [^true].
		probe := probe superclass].
	^false."! !


!Object methodsFor: 'predicates'!

isMemberOf: class
	^self class == class.! !


!Object methodsFor: 'predicates'!

isNil
	"Usually inlined by the compiler."
	^false.! !


!Object methodsFor: 'predicates'!

notNil
	^true.! !


!Object methodsFor: 'predicates'!

isBytes
	^(self class layout bitAnd: 8192) ~~ 0.! !


!Object methodsFor: 'predicates'!

respondsTo: selector
	^self class canUnderstand: selector.! !


!Object methodsFor: 'copying'!

postCopy
	^self.! !


!Object methodsFor: 'copying'!

shallowCopy
	<primitive: 18>! !


!Object methodsFor: 'copying'!

copy
	^self shallowCopy postCopy.! !


!Object methodsFor: 'dependents'!

update: aspect
	^self.! !


!Object methodsFor: 'dependents'!

update: aspect with: parameter
	^self update: aspect.! !


!Object methodsFor: 'dependents'!

update: aspect with: parameter from: object
	^self
		update: aspect
		with: parameter.! !


!Object methodsFor: 'system operations'!

become: other
	<primitive: 20>
	^self primitiveFailed.! !


!Object methodsFor: 'system operations'!

orIfNil: block
	^self.! !


!Object methodsFor: 'system operations'!

perform: selector
	<primitive: 13>
	^self primitiveFailed.! !


!Object methodsFor: 'system operations'!

perform: selector with: argument
	<primitive: 14>
	^self primitiveFailed.! !


!Object methodsFor: 'system operations'!

perform: selector with: argument with: argument2
	<primitive: 15>
	^self primitiveFailed.! !


!Object methodsFor: 'system operations'!

perform: selector with: argument with: argument2 with: argument3
	<primitive: 16>
	^self primitiveFailed.! !


!Object methodsFor: 'system operations'!

basicChangeClassTo: newClass
	<primitive: 49>! !


!Object methodsFor: 'system operations'!

asOOP
	<primitive: 30>! !


!Object methodsFor: 'system operations'!

perform: selector withArguments: array
	<primitive: 17>
	^self primitiveFailed.! !


!Object methodsFor: 'comparing'!

~~ object
	^self ~~ object.! !


!Object methodsFor: 'comparing'!

~= object
	^(self = object) not.! !


!Object methodsFor: 'comparing'!

= object
	^self == object.! !


!Object methodsFor: 'comparing'!

== object
	^self == object.! !


!Object methodsFor: 'comparing'!

hash
	<primitive: 19>! !


!Object methodsFor: 'comparing'!

identityHash
	"It's just the object table entry of the receiver converted to a SmallInteger."
	"Do not override in any subclass."
	<primitive: 19>! !


!Object methodsFor: 'accessing'!

at: index
	<primitive: 5>
	^self error: #outOfBounds.! !


!Object methodsFor: 'accessing'!

basicAt: index
	<primitive: 5>
	^self error: #outOfBounds.! !


!Object methodsFor: 'accessing'!

basicAt: index put: value
	<primitive: 6>
	^self primitiveFailed.! !


!Object methodsFor: 'accessing'!

basicSize
	"Answer the number of indexed slots in the receiver. "
	"Non-indexed objects answer 0."
	"Do not override in any subclass."
	<primitive: 4>! !


!Object methodsFor: 'accessing'!

class
	<primitive: 21>! !


!Object methodsFor: 'accessing'!

instVarAt: index
	<primitive: 23>
	^self primitiveFailed.! !


!Object methodsFor: 'accessing'!

instVarAt: index put: value
	<primitive: 24>
	^self primitiveFailed.! !


!Object methodsFor: 'accessing'!

size
	"Answer the number of slots in the receiver."
	<primitive: 4>! !


!Object methodsFor: 'accessing'!

yourself
	^self.! !


!Object methodsFor: 'accessing'!

at: index put: value
	<primitive: 6>
	^self error: #outOfBounds.! !


!Object methodsFor: 'error handling'!

error
	self error: #error.! !


!Object methodsFor: 'error handling'!

mustBeBoolean
	^self error: #mustBeBoolean.! !


!Object methodsFor: 'error handling'!

primitiveFailed
	^self error: #primitiveFailed.! !


!Object methodsFor: 'error handling'!

subclassResponsibility
	^self error: #subclassResponsibility.! !


!Object methodsFor: 'error handling'!

shouldNotImplement
	^self error: #shouldNotImplement.! !


!Object methodsFor: 'error handling'!

basicError: message
	<primitive: 1>! !


!Object methodsFor: 'error handling'!

halt
	^self error: #haltEncountered.! !


!Object methodsFor: 'error handling'!

doesNotUnderstand: message
	| text |
	text := Context textOfSymbol: message selector.
	self error: self printString, ' does not understand #', text.! !


!Object methodsFor: 'error handling'!

badTrapArgument: systrapNumber
	^self error: 'Bad args to trap ', systrapNumber printString.! !


!Smalltalk class methodsFor: 'startup'!

basicStart
	"Sent by the virtual machine upon startup.  This is the first Smalltalk method that executes."
	CPointer initialize.  "create PadBuffer"
	self start.
	^self exit.! !


!Smalltalk class methodsFor: 'utility'!

collectGarbage
	<primitive: 12>! !


!Smalltalk class methodsFor: 'utility'!

exit
	<primitive: 2>! !


!Smalltalk class methodsFor: 'utility'!

runningOnDevice
	<primitive: 3>! !


!Smalltalk class methodsFor: 'utility'!

freeMemory
	"Number of free bytes in the Smalltalk heap."
	<primitive: 28>! !


!Smalltalk class methodsFor: 'startup'!

start
"program start executes this object"
       AidForm show.! !


!String methodsFor: 'accessing'!

at: index put: value
	self basicAt: index put: value asInteger.
	^value.! !


!PalmOS class methodsFor: 'accessing'!

getClipboardString
	| handle length string |
	handle := SYSTRAP ClipboardGetItem: 0 with: PadBuffer.
	length := PadBuffer wordAt: 0.
	string := String new: length.
	SYSTRAP 
		MemMove: string
		from: handle lock
		bytes: length.
	handle unlock.
	^string! !


!PalmOS class methodsFor: 'accessing'!

putClipboardString: aStringOrByteArray 
	SYSTRAP 
		ClipboardAddItem: 0
		with: aStringOrByteArray
		with: aStringOrByteArray size! !


!TextField methodsFor: 'accessing'!

setScrollbar: scrollValueHolder
      "BJH"
      | pad maximum |
      
      pad := PadBuffer.
      SYSTRAP FldGetScrollValues: self getPointer 
                scrollPosP: (pad offsetBy: 4)      
            textHeightP: (pad offsetBy: 8) 
                fieldHeightP: (pad offsetBy: 12).
      
      maximum := (pad wordAt: 8)  - (pad wordAt: 12).
      maximum <= 0 ifTrue: [
            (pad wordAt: 4) > 0 ifTrue: [
                  maximum := pad wordAt: 4.
            ] ifFalse: [
                  maximum := 0.
            ].
      ].
            
      scrollValueHolder min: 0;
                    max: maximum;
                    pageSize: (1 max: (pad wordAt: 12)  - 1);
                    value: (pad wordAt: 4).
! !


!Application methodsFor: 'events'!

onKeyDown: key modifiers: modifiers
	^self.! !


!Application methodsFor: 'event handling'!

handlePenUpEvent
	self onPenUpAt: CEvent lastPosition.
	^false.! !


!Application methodsFor: 'event handling'!

handleListExitEvent
	^self handleControlExitEvent.! !


!Application methodsFor: 'event handling'!

handleFieldHeightChangedEvent
	| control |
	control := self widgetWithID: (CEvent lastArgument: 0).
	control ifNotNil: [control changed: #height].
	^false.! !


!Application methodsFor: 'event handling'!

handleTableSelectEvent
	"Tables not implemented yet ..."
	^false.! !


!Application methodsFor: 'event handling'!

handleTableEnterEvent
	"Tables not implemented yet ..."
	^false.! !


!Application methodsFor: 'event handling'!

handleFormSaveEvent
	"No idea what this is for."
	^false.! !


!Application methodsFor: 'initialization'!

releaseWidgets
	widgets do: [:each | each release].! !


!Application methodsFor: 'accessing'!

widgetWithID: id
	^widgetsByID at: id ifAbsent: [nil].! !


!Application methodsFor: 'initialization'!

initialize
	widgetsByName := IdentityDictionary new.
	widgetsByID := IdentityDictionary new.
	widgets := IdentityList new.
	menuActions := IdentityDictionary new.! !


!Application methodsFor: 'event handling'!

handleScrollbarEnterEvent
	^self handleControlEnterEvent.! !


!Application methodsFor: 'event handling'!

handleControlRepeatEvent
	^self handleControlSelectEvent.! !


!Application methodsFor: 'events'!

onPenDownAt: position
	^self.! !


!Application methodsFor: 'event handling'!

handleFormLoadEvent
	Form initForm: (CEvent lastArgument: 0).
	self initializeWidgets.
	^true.! !


!Application methodsFor: 'event handling'!

handleFormOpenEvent
	| formPtr |
	formPtr := SYSTRAP FrmGetActiveForm.
	SYSTRAP FrmDrawForm: formPtr.
	self onOpened.
	^true.! !


!Application methodsFor: 'events'!

onPenMoveAt: position
	^self.! !


!Application methodsFor: 'event handling'!

handleFormUpdateEvent
	"not really sure what this is supposed to do..."
	^false.! !


!Application methodsFor: 'control flow'!

eventLoop
	[self getNextEvent or: [self handleLastEvent]]
		whileTrue.! !


!Application methodsFor: 'event handling'!

handlePenDownEvent
	self onPenDownAt: CEvent lastPosition.
	^false.! !


!Application methodsFor: 'event handling'!

handleScrollbarExitEvent
	| control  |
	control := self widgetWithID: (CEvent lastArgument: 0).
	control ifNotNil: [
		control immediate ifFalse: [
			control
				scrollTo: (CEvent lastArgument: 4)
				oldValue: (CEvent lastArgument: 3)].
		control changed: #exited].
	^false.! !


!Application methodsFor: 'initialization'!

release
	"Sent when the application 'terminates'; i.e., when another form is activated."
	self releaseWidgets.! !


!Application methodsFor: 'events'!

onVirtualKeyDown: key modifiers: modifiers
	^self.! !


!Application methodsFor: 'event handling'!

handleListSelectEvent
	| id control |
	id := CEvent lastArgument: 0.
	control := self widgetWithID: id.
	control ifNotNil: [
		control onSelected: (CEvent lastArgument: 3) + 1.
		control changed: #selected].
	^false.! !


!Application methodsFor: 'event handling'!

handleTableExitEvent
	"Tables not implemented yet ..."
	^false.! !


!Application methodsFor: 'event handling'!

handleWindowExitEvent
	^false.! !


!Application methodsFor: 'accessing'!

nextToRun: app
	nextToRun := app.! !


!Application methodsFor: 'initialization'!

add: formObjectClass
id: objectID
name: objectName
aspect: objectAspect
	| object |
	object := formObjectClass new.
	object
		id: objectID
		name: objectName
		aspect: objectAspect.
	objectName ifNotNil: [
			widgetsByName at: objectName put: object].
	widgetsByID at: objectID put: object.
	widgets add: object.! !


!Application methodsFor: 'event handling'!

handleControlSelectEvent
	| id control |
	id := CEvent lastArgument: 0.
	control := self widgetWithID: id.
	control ifNotNil: [
		control onSelected.
		control changed: #selected].
	^false.! !


!Application methodsFor: 'events'!

onPenUpAt: position
	^self.! !


!Application methodsFor: 'accessing'!

widgetNamed: name
	^widgetsByName at: name.! !


!Application methodsFor: 'event handling'!

handleWindowEnterEvent
	^false.! !


!Application methodsFor: 'event handling'!

handleListEnterEvent
	^self handleControlEnterEvent.! !


!Application methodsFor: 'event handling'!

handleControlExitEvent
	| control |
	control := self widgetWithID: (CEvent lastArgument: 0).
	control ifNotNil: [control changed: #exited].
	^false.! !


!Application methodsFor: 'utility'!

isDirty
	^(SYSTRAP FrmGetUserModifiedState: Form activeFormPointer)
		asBoolean.! !


!Application methodsFor: 'event handling'!

handleFormTitleEnterEvent
	^false.! !


!Application methodsFor: 'event handling'!

handleNilEvent
	^true.! !


!Application methodsFor: 'event handling'!

handleAppStopEvent
	Smalltalk exit.
	^false.! !


!Application methodsFor: 'control flow'!

handleLastEvent
	| event selectors type |
	event := CEvent last.
	type := event eventType.
	selectors := self class eventHandlerSelectors.
	(selectors includesKey: type + 1)
		ifFalse: [^true].  "unknown event type!!"
	(self perform: (selectors at: type + 1)) 
		ifFalse: [CEvent formHandleEvent: event].
	^type ~~ ##frmCloseEvent.! !


!Application methodsFor: 'utility'!

clearDirty
	SYSTRAP FrmSetNotUserModified: Form activeFormPointer.! !


!Application methodsFor: 'event handling'!

handleFormGotoEvent
	"only for special launch codes..."
	^false.! !


!Application methodsFor: 'initialization'!

createMenus
	"Forms with menus should override this to create the menu actions (using #addMenuAction:forID:)."
	^self.! !


!Application methodsFor: 'event handling'!

handlePenMoveEvent
	self onPenMoveAt: CEvent lastPosition.
	^false.! !


!Application methodsFor: 'event handling'!

handlePopSelectEvent
	"Send it to the list object, not the popup trigger."
	| id control |
	id := CEvent lastArgument: 3.
	control := self widgetWithID: id.
	control ifNotNil: [
		control onSelected: (CEvent lastArgument: 6) + 1.
		control changed: #selected].
	^false.! !


!Application methodsFor: 'event handling'!

handleFormTitleSelectEvent
	^false.! !


!Application methodsFor: 'control flow'!

getNextEvent
	"Answer true if event was handled by the system, false if the receiver should handle it."
	| event |
	event := CEvent waitForEvent: self eventTimeout.
	^CEvent sysHandleEvent: event.! !


!Application methodsFor: 'event handling'!

handleFormCloseEvent
	self release.
	^false.  "let PalmOS clean up"! !


!Application methodsFor: 'accessing'!

nextToRun
	^nextToRun.! !


!Application methodsFor: 'event handling'!

handleControlEnterEvent
	| control |
	control := self widgetWithID: (CEvent lastArgument: 0).
	control ifNotNil: [control changed: #entered].
	^false.! !


!Application methodsFor: 'event handling'!

handleMenuEvent
	| id selector |
	id := CEvent lastArgument: 0.
	selector := menuActions at: id ifAbsent: [nil].
	selector ifNotNil: [self perform: selector].
	^false.! !


!Application methodsFor: 'initialization'!

initializeWidgets
	widgets do: [:each | 
		each application: self.
		each acquireModel].! !


!Application methodsFor: 'initialization'!

create
	self createComponents.
	self createMenus.! !


!Application methodsFor: 'event handling'!

handleFieldEnterEvent
	^self handleControlEnterEvent.! !


!Application methodsFor: 'initialization'!

addMenuAction: selector forID: menuID
	menuActions at: menuID put: selector.! !


!Application methodsFor: 'initialization'!

createComponents
	"Subclasses override to create form objects."
	^self.! !


!Application methodsFor: 'event handling'!

eventTimeout
	"May be overridden by subclasses that want to do 'polling' event loops."
	^-1.! !


!Application methodsFor: 'event handling'!

handleDaySelectEvent
	^false.! !


!Application class methodsFor: 'utility'!

show
	^self showFor: self new.! !


!Application class methodsFor: 'utility'!

consumeExcessEvents
	| event |
	[event := CEvent waitForEvent: -1.
	 CEvent sysHandleEvent: event.
	 event eventType == ##frmLoadEvent] whileFalse.! !


!Application class methodsFor: 'accessing'!

eventHandlerSelectors
	^#(handleNilEvent handlePenDownEvent handlePenUpEvent handlePenMoveEvent handleKeyDownEvent handleWindowEnterEvent handleWindowExitEvent handleControlEnterEvent handleControlExitEvent handleControlSelectEvent handleControlRepeatEvent handleListEnterEvent handleListSelectEvent handleListExitEvent handlePopSelectEvent handleFieldEnterEvent handleFieldHeightChangedEvent handleFieldChangedEvent handleTableEnterEvent handleTableSelectEvent handleDaySelectEvent handleMenuEvent handleAppStopEvent handleFormLoadEvent handleFormOpenEvent handleFormGotoEvent handleFormUpdateEvent handleFormSaveEvent handleFormCloseEvent handleFormTitleEnterEvent handleFormTitleSelectEvent handleTableExitEvent handleScrollbarEnterEvent handleScrollbarExitEvent handleScrollbarRepeatEvent).! !


!Application class methodsFor: 'utility'!

showFor: instance
	| temp |
	Form gotoForm: self formID.
	[instance isNil] whileFalse: [
		self consumeExcessEvents.
		instance create.
		instance handleLastEvent.
		instance eventLoop.
		temp := instance nextToRun.
		instance nextToRun: nil.  "clear forward reference"
		"Note: hard assignment is used here to avoid keeping a perpetual reference to the first shown application...this is one of the few places where ::= is actually required"
		instance ::= temp].! !


!Application class methodsFor: 'instance creation'!

new
	^super new initialize.! !


!Application class methodsFor: 'accessing'!

formID
	^self subclassResponsibility.! !


!TextField methodsFor: 'utility'!

scroll: lines direction: direction
      "BJH"      "direction must be ##upDirection or ##downDirection."

      SYSTRAP      FldScrollField: self getPointer lines: lines  direction: (direction bitShift: 8).
! !


!Database methodsFor: 'uncategorized'!

setBackupBitForDB: localID
	"Answer an Array with the following elements:
		1:	String with the database name
		2:	attributes value
		3:	creation date (Integer)
		4:	modification date (Integer)
		5:	backup date (Integer)
		6:	modification number
		7:	type ID (Integer)
		8:	creator ID (Integer)"
	| pad null array attributes  |
	pad := PadBuffer.
	null := CPointer null.
	
	SYSTRAP
		DmDatabaseInfo: 0
		localID: localID
		nameP: pad
		attributesP: (pad offsetBy: 32)
		versionP: null
		crDateP: (pad offsetBy: 34)
		modDateP: (pad offsetBy: 38)
		bckUpDateP: (pad offsetBy: 42)
		modNumP: (pad offsetBy: 46)
		appInfoIDP: null
		sortInfoIDP: null
		typeP: (pad offsetBy: 50)
		creatorP: (pad offsetBy: 54).
	pad wordAt: 32 put: ( ( pad wordAt: 32 ) bitOr: ##dmHdrAttrBackup) .
		
	SYSTRAP
		DmSetDatabaseInfo: 0
		localID: localID
		nameP: null
		attributesP: ( pad offsetBy: 32 ) 
		versionP: null
		crDateP: null
		modDateP: null
		bckUpDateP: null
		modNumP: null
		appInfoIDP: null
		sortInfoIDP: null
		typeP: null
		creatorP: null.

! !


